// Copyright (c) 2015 Nuxi, https://nuxi.nl/
//
// SPDX-License-Identifier: BSD-2-Clause

#include <inttypes.h>
#include <stdio.h>
#include <string.h>
#include <testing.h>

TEST(printf_scanf, examples) {
  char buf[11];
  ASSERT_EQ(10, snprintf(buf, sizeof(buf), "%" PRIdLEAST16 " %" PRIdPTR,
                         (int_least16_t)12345, (intptr_t)6789));
  ASSERT_STREQ("12345 6789", buf);

  uint_fast16_t v;
  ASSERT_EQ(1, sscanf(buf, "%" SCNdFAST16, &v));
  ASSERT_EQ(12345, v);
}

TEST(printf_scanf, all_defined) {
  // clang-format off
  ASSERT_LE(154, strlen(
      PRId8 PRIi8 PRIo8 PRIu8 PRIx8 PRIX8 PRId16 PRIi16 PRIo16 PRIu16
      PRIx16 PRIX16 PRId32 PRIi32 PRIo32 PRIu32 PRIx32 PRIX32 PRId64
      PRIi64 PRIo64 PRIu64 PRIx64 PRIX64 PRIdLEAST8 PRIiLEAST8
      PRIoLEAST8 PRIuLEAST8 PRIxLEAST8 PRIXLEAST8 PRIdLEAST16
      PRIiLEAST16 PRIoLEAST16 PRIuLEAST16 PRIxLEAST16 PRIXLEAST16
      PRIdLEAST32 PRIiLEAST32 PRIoLEAST32 PRIuLEAST32 PRIxLEAST32
      PRIXLEAST32 PRIdLEAST64 PRIiLEAST64 PRIoLEAST64 PRIuLEAST64
      PRIxLEAST64 PRIXLEAST64 PRIdFAST8 PRIiFAST8 PRIoFAST8 PRIuFAST8
      PRIxFAST8 PRIXFAST8 PRIdFAST16 PRIiFAST16 PRIoFAST16 PRIuFAST16
      PRIxFAST16 PRIXFAST16 PRIdFAST32 PRIiFAST32 PRIoFAST32 PRIuFAST32
      PRIxFAST32 PRIXFAST32 PRIdFAST64 PRIiFAST64 PRIoFAST64 PRIuFAST64
      PRIxFAST64 PRIXFAST64 PRIdMAX PRIiMAX PRIoMAX PRIuMAX PRIxMAX
      PRIXMAX PRIdPTR PRIiPTR PRIoPTR PRIuPTR PRIxPTR PRIXPTR

      SCNd8 SCNi8 SCNo8 SCNu8 SCNx8 SCNd16 SCNi16 SCNo16 SCNu16 SCNx16
      SCNd32 SCNi32 SCNo32 SCNu32 SCNx32 SCNd64 SCNi64 SCNo64 SCNu64
      SCNx64 SCNdLEAST8 SCNiLEAST8 SCNoLEAST8 SCNuLEAST8 SCNxLEAST8
      SCNdLEAST16 SCNiLEAST16 SCNoLEAST16 SCNuLEAST16 SCNxLEAST16
      SCNdLEAST32 SCNiLEAST32 SCNoLEAST32 SCNuLEAST32 SCNxLEAST32
      SCNdLEAST64 SCNiLEAST64 SCNoLEAST64 SCNuLEAST64 SCNxLEAST64
      SCNdFAST8 SCNiFAST8 SCNoFAST8 SCNuFAST8 SCNxFAST8 SCNdFAST16
      SCNiFAST16 SCNoFAST16 SCNuFAST16 SCNxFAST16 SCNdFAST32 SCNiFAST32
      SCNoFAST32 SCNuFAST32 SCNxFAST32 SCNdFAST64 SCNiFAST64 SCNoFAST64
      SCNuFAST64 SCNxFAST64 SCNdMAX SCNiMAX SCNoMAX SCNuMAX SCNxMAX
      SCNdPTR SCNiPTR SCNoPTR SCNuPTR SCNxPTR));
  // clang-format on
}
